#ifndef DMD_H_BASICS
#define DMD_H_BASICS

// Basic C library stuff, mainly types.
// This is some basic stuff you have to be careful with, include before any other header!

// Need to take care to get the printf fun I need.
#define __STDC_FORMAT_MACROS
#include <sys/types.h>
#include <stdint.h>   // C99, p.ex. intmax_t
#include <inttypes.h> // C99 integer format stuff

// Consistent integer printing...
// Offsets are cast to intmax_t, printed as such.
typedef intmax_t off_p;
#define OFF_P PRIiMAX

// One could do the same for size_t, but I really assume that this type is there and %zu is used at several places.
// For portability, one could replace those with some SIZE_P.

#include <cstdlib>
static inline const char* safe_string(const char *in)
{
	if(in == NULL) return "";
	else return in;
}

#include <cstring>
#include <stdio.h>
#include <cmath>

// Hack for Solaris.
#ifdef NODEV
#undef NODEV
#endif

// No cunistd there ... ?
#include <unistd.h>

#include <cstddef>

#include "threads/thread_niceness.hxx"

#endif
